## Module of time functions called by central.py
## L. Nobre G.
## 2004
import math

def linfunc( lowlim, higlim, totalnum, index ):
    return lowlim+(higlim-lowlim)*(index-1.0)/(totalnum-1.0)

def logfunc( lowlim, higlim, totalnum, index ):
    fracval = (index-1.0)/(totalnum-1.0)
    return lowlim*(higlim/lowlim)**fracval

def tanfunc( lowlim, higlim, totalnum, index ):
    fracval = (index-1.0)/(totalnum-1.0)
    newfrac = 0.506783654906304*math.tanh(5.0*(fracval-0.5))+0.5
    return lowlim+(higlim-lowlim)*newfrac

def sinfunc( lowlim, higlim, totalnum, index ):
    fracval = (index-1.0)/(totalnum-1.0)
    newfrac = math.pow(math.sin(0.5*math.pi*fracval),2)
    return lowlim+(higlim-lowlim)*newfrac

def gobakfu( lowlim, higlim, totalnum, index ):
    fracval = (index-1.0)/(totalnum-1.0)
    newfrac = math.pow(math.sin(math.pi*fracval),2)
    return lowlim+(higlim-lowlim)*newfrac

