#!/usr/bin/env python
## This is an MPEG frame generator
import sys, os, string, math
mpostfile = open( sys.argv[1] ).read()
conv_file = open( "central.sh" ).read()
mpgencile = open( "central.en" ).read()
prevlastframi = 0
totalframenum = 30
lowparamlimit = 0
higparamlimit = 1

def linfunc( lowlim, higlim, totalnum, index ):
    return lowlim+(higlim-lowlim)*(index-1.0)/(totalnum-1.0)

def logfunc( lowlim, higlim, totalnum, index ):
    fracval = (index-1.0)/(totalnum-1.0)
    return lowlim*(higlim/lowlim)**fracval

def tanfunc( lowlim, higlim, totalnum, index ):
    fracval = (index-1.0)/(totalnum-1.0)
    newfrac = 0.506783654906304*math.tanh(5.0*(fracval-0.5))+0.5
    return lowlim+(higlim-lowlim)*newfrac

def sinfunc( lowlim, higlim, totalnum, index ):
    fracval = (index-1.0)/(totalnum-1.0)
    newfrac = math.pow(math.sin(0.5*math.pi*fracval),2)
    return lowlim+(higlim-lowlim)*newfrac

originalfrstr = "0000"
framstrnumdig = len( originalfrstr )
firstframeind = prevlastframi+1
lastframindex = prevlastframi+totalframenum
for i in range( 1, totalframenum+1 ):
    actualparamval = sinfunc( lowparamlimit, higparamlimit, totalframenum, i )
    actualparamstr = "%f" % actualparamval
    actualindexbas = str( i + prevlastframi ) 
    actualindexpad = originalfrstr[:framstrnumdig-len( actualindexbas )] 
    actualindexstr = actualindexpad + actualindexbas
    mirrorindexbas = str( prevlastframi + 2*totalframenum - i + 1 ) 
    mirrorindexpad = originalfrstr[:framstrnumdig-len( mirrorindexbas )] 
    mirrorindexstr = mirrorindexpad + mirrorindexbas
    tmpmpost = open( "frame%s.mp" % actualindexstr, 'w' )
    tmpmpost.write( mpostfile.replace( 'SingleContinuosParameter', actualparamstr ) )
    tmpmpost.close()
    tmp_conv = open( "conv_%s.sh" % actualindexstr, 'w' )
    fir_file = conv_file.replace( 'TheFrameNumber', actualindexstr )
    tmp_conv.write( fir_file.replace( 'MirrorTimeReversed', mirrorindexstr ) )
    tmp_conv.close()

tmpencod = open( "encode.Params", 'w' )
actualindexbas = str( lastframindex ) 
actualindexpad = originalfrstr[:framstrnumdig-len( actualindexbas )] 
actualindexstr = actualindexpad + actualindexbas
replacedencile = mpgencile.replace( 'LastFrameIndexStr', actualindexstr )
actualindexbas = str( firstframeind ) 
actualindexpad = originalfrstr[:framstrnumdig-len( actualindexbas )] 
actualindexstr = actualindexpad + actualindexbas
tmpencod.write( replacedencile.replace( 'FirstFrameIndexStr',actualindexstr ))
tmpencod.close()

